// OpenCallback.cpp

#include "StdAfx.h"
#include "resource.h"		//	ǉ
#include "DialogProc.h"		//	ǉ

#include "../../Console/OpenCallback.h"	// pXύX

//#include "Common/StdOutStream.h"	// 폜
//#include "Common/StdInStream.h"	// 폜
#include "Common/StringConvert.h"

#include "Interface/FileStreams.h"

#include "Windows/PropVariant.h"

#include "ConsoleCloseUtils.h"

extern HINSTANCE g_hInstance;	//	ǉ

// IWi
STDMETHODIMP COpenCallbackImp::SetTotal(const UINT64 *files, const UINT64 *bytes)
{
  if (NConsoleClose::TestBreakSignal())
    return E_ABORT;
  return S_OK;
}

// IWi
STDMETHODIMP COpenCallbackImp::SetCompleted(const UINT64 *files, const UINT64 *bytes)
{
  if (NConsoleClose::TestBreakSignal())
    return E_ABORT;
  return S_OK;
}
  
// IWi
STDMETHODIMP COpenCallbackImp::GetProperty(PROPID propID, PROPVARIANT *value)
{
  NWindows::NCOM::CPropVariant propVariant;
  switch(propID)
  {
  case kpidName:
    propVariant = GetUnicodeString(_fileInfo.Name, CP_OEMCP);
    break;
  case kpidIsFolder:
    propVariant = _fileInfo.IsDirectory();
    break;
  case kpidSize:
    propVariant = _fileInfo.Size;
    break;
  case kpidAttributes:
    propVariant = (UINT32)_fileInfo.Attributes;
    break;
  case kpidLastAccessTime:
    propVariant = _fileInfo.LastAccessTime;
    break;
  case kpidCreationTime:
    propVariant = _fileInfo.CreationTime;
    break;
  case kpidLastWriteTime:
    propVariant = _fileInfo.LastWriteTime;
    break;
  }
  propVariant.Detach(value);
  return S_OK;
}

// IWi
STDMETHODIMP COpenCallbackImp::GetStream(const wchar_t *name, 
    IInStream **inStream)
{
  *inStream = NULL;
  CSysString fullPath = _folderPrefix + GetSystemString(name, CP_OEMCP);
  if (!NWindows::NFile::NFind::FindFile(fullPath, _fileInfo))
    return S_FALSE;
  if (_fileInfo.IsDirectory())
    return S_FALSE;
  CComObjectNoLock<CInFileStream> *inFile = new CComObjectNoLock<CInFileStream>;
  CComPtr<IInStream> inStreamTemp = inFile;
  if (!inFile->Open(fullPath))
    return ::GetLastError();
  *inStream = inStreamTemp.Detach();
  return S_OK;
}

// 啝ɕύX
STDMETHODIMP COpenCallbackImp::CryptoGetTextPassword(BSTR *password)
{
	if (!PasswordIsDefined)
	{
//		g_StdOut << "\nEnter password:";
//		AString oemPassword = g_StdIn.ScanStringUntilNewLine();
//		Password = MultiByteToUnicodeString(oemPassword, CP_OEMCP); 
//		PasswordIsDefined = true;
		
		/* ǉ */
		char lpBuffer[64];
		::LoadString(g_hInstance, IDS_DECRYPT, lpBuffer, 64);
		LPSTR lpPassword = lpBuffer;
		HWND hWnd = g_StdOut.GetOutDialogHandle();
		if (hWnd == NULL)
			hWnd = g_StdOut.GetOwnerWindow();
		int nRes = ::DialogBoxParam(g_hInstance, MAKEINTRESOURCE(IDD_PASSWORD), hWnd, PasswordDialogProc, (LPARAM)&lpPassword);
		if (nRes == IDCANCEL)
			return E_ABORT;
		if (lpPassword)
		{
			AString anOemPassword = lpPassword;
			::GlobalFree(lpPassword);
			Password = MultiByteToUnicodeString(anOemPassword, CP_OEMCP); 
		}
		else
			Password = L"";
		PasswordIsDefined = true;
		/* ǉ܂ */
		
	}
	CComBSTR temp = Password;
	*password = temp.Detach();
	return S_OK;
}

